package cn.ibizlab.core.avuedata.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.util.domain.EntityBase;
import cn.ibizlab.util.annotation.DEField;
import cn.ibizlab.util.enums.DEPredefinedFieldType;
import cn.ibizlab.util.enums.DEFieldDefaultValueType;
import cn.ibizlab.util.helper.DataObject;
import cn.ibizlab.util.enums.DupCheck;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.util.annotation.Audit;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[可视化配置表]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "blade_visual_config", resultMap = "BladeVisualConfigResultMap")
@ApiModel("可视化配置表")
public class BladeVisualConfig extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @DEField(isKeyField = true)
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    @JSONField(name = "id")
    @JsonProperty("id")
    @ApiModelProperty("主键")
    private Long id;
    /**
     * 可视化表主键
     */
    @DEField(name = "visual_id")
    @TableField(value = "visual_id")
    @JSONField(name = "visualid")
    @JsonProperty("visualid")
    @ApiModelProperty("可视化表主键")
    private Long visualid;
    /**
     * 组件json
     */
    @TableField(value = "component")
    @JSONField(name = "component")
    @JsonProperty("component")
    @ApiModelProperty("组件json")
    private String component;
    /**
     * 配置json
     */
    @TableField(value = "detail")
    @JSONField(name = "detail")
    @JsonProperty("detail")
    @ApiModelProperty("配置json")
    private String detail;



    /**
     * 设置 [可视化表主键]
     */
    public void setVisualid(Long visualid) {
        this.visualid = visualid;
        this.modify("visual_id", visualid);
    }

    /**
     * 设置 [组件json]
     */
    public void setComponent(String component) {
        this.component = component;
        this.modify("component", component);
    }

    /**
     * 设置 [配置json]
     */
    public void setDetail(String detail) {
        this.detail = detail;
        this.modify("detail", detail);
    }


    @Override
    public Serializable getDefaultKey(boolean gen) {
        return IdWorker.getId();
    }
    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("id");
        return super.copyTo(targetEntity, bIncEmpty);
    }
}


